Added latest version support for git storage

without this change you always have to pass the concrete version for git based storage
with this change we support passing of a latests version

fixes gh-745
This commit is contained in:
Marcin Grzejszczak
2019-01-10 16:04:32 +01:00
parent e12b0b74b6
commit ea65ae3553
120 changed files with 3170 additions and 23 deletions

View File

@@ -503,7 +503,14 @@ Under `META-INF` folder:
* we group applications via `groupId` (e.g. `com.example`)
* then each application is represented via the `artifactId` (e.g. `beer-api-producer-git`)
* next, the version of the application. The version is mandatory! (e.g. `0.0.1-SNAPSHOT`)
* next, the version of the application (e.g. `0.0.1-SNAPSHOT`). Starting from Spring Cloud Contract version `2.1.0`, you can specify the versions as follows (assuming that your versions follow the semantic versioning)
** `+` or `latest` - to find the latest version of your stubs (assuming that the snapshots are always the latest artifact for a given revision number). That means:
*** if you have a version `1.0.0.RELEASE`, `2.0.0.BUILD-SNAPSHOT` and `2.0.0.RELEASE` we will assume that the latest is `2.0.0.BUILD-SNAPSHOT`
*** if you have a version `1.0.0.RELEASE` and `2.0.0.RELEASE` we will assume that the latest is `2.0.0.RELEASE`
*** if you have a version called `latest` or `+` we will pick that folder
** `release` - to find the latest release version of your stubs. That means:
*** if you have a version `1.0.0.RELEASE`, `2.0.0.BUILD-SNAPSHOT` and `2.0.0.RELEASE` we will assume that the latest is `2.0.0.RELEASE`
*** if you have a version called `release` we will pick that folder
* finally, there are two folders:
** `contracts` - the good practice is to store the contracts required by each
consumer in the folder with the consumer name (e.g. `beer-api-consumer`). That way you

View File

@@ -370,6 +370,11 @@
<artifactId>maven-aether-provider</artifactId>
<version>${maven.version}</version>
</dependency>
<dependency>
<groupId>org.apache.maven</groupId>
<artifactId>maven-artifact</artifactId>
<version>${maven.version}</version>
</dependency>
<dependency>
<groupId>org.apache.maven</groupId>
<artifactId>maven-settings-builder</artifactId>

View File

@@ -52,6 +52,11 @@
<artifactId>maven-aether-provider</artifactId>
<optional>true</optional>
</dependency>
<dependency>
<groupId>org.apache.maven</groupId>
<artifactId>maven-artifact</artifactId>
<optional>true</optional>
</dependency>
<dependency>
<groupId>org.apache.maven</groupId>
<artifactId>maven-settings-builder</artifactId>

View File

@@ -28,13 +28,18 @@ import java.nio.file.PathMatcher;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.util.AbstractMap;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.concurrent.ConcurrentHashMap;
import java.util.stream.Collectors;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import shaded.org.apache.maven.artifact.versioning.DefaultArtifactVersion;
import org.springframework.cloud.contract.stubrunner.spring.StubRunnerProperties;
import org.springframework.core.io.AbstractResource;
import org.springframework.core.io.Resource;
@@ -177,11 +182,6 @@ class GitStubDownloader implements StubDownloader {
@Override
public Map.Entry<StubConfiguration, File> downloadAndUnpackStubJar(
StubConfiguration stubConfiguration) {
if (StringUtils.isEmpty(stubConfiguration.version)
|| "+".equals(stubConfiguration.version)) {
throw new IllegalStateException("Concrete version wasn't passed for ["
+ stubConfiguration.toColonSeparatedDependencyNotation() + "]");
}
try {
if (log.isDebugEnabled()) {
log.debug("Trying to find a contract for ["
@@ -278,13 +278,25 @@ class GitStubDownloaderProperties {
class FileWalker extends SimpleFileVisitor<Path> {
private static final Log log = LogFactory.getLog(FileWalker.class);
private static final List<String> LATEST = Arrays.asList("latest", "+");
private static final String RELEASE = "release";
private final PathMatcher matcherWithDot;
private final PathMatcher matcherWithoutDot;
Path foundFile;
private final boolean latestSnapshotVersion;
private final boolean latestReleaseVersion;
FileWalker(StubConfiguration stubConfiguration) {
this.latestSnapshotVersion = LATEST.stream().anyMatch(
s -> s.equals(stubConfiguration.version.toLowerCase()));
this.latestReleaseVersion = RELEASE.equals(stubConfiguration.version.toLowerCase());
this.matcherWithDot = FileSystems.getDefault()
.getPathMatcher("glob:" + matcherGlob(stubConfiguration, "."));
this.matcherWithoutDot = FileSystems.getDefault()
@@ -294,7 +306,8 @@ class FileWalker extends SimpleFileVisitor<Path> {
private String matcherGlob(StubConfiguration stubConfiguration,
String groupArtifactSeparator) {
return "**" + stubConfiguration.groupId + groupArtifactSeparator
+ stubConfiguration.artifactId + "/" + stubConfiguration.version;
+ stubConfiguration.artifactId + "/" + (this.latestSnapshotVersion ||
this.latestReleaseVersion ? "**" : stubConfiguration.version);
}
@Override
@@ -302,10 +315,104 @@ class FileWalker extends SimpleFileVisitor<Path> {
throws IOException {
if (this.matcherWithDot.matches(dir.toAbsolutePath())
|| this.matcherWithoutDot.matches(dir.toAbsolutePath())) {
this.foundFile = dir;
if (this.latestSnapshotVersion || this.latestReleaseVersion) {
// folders with name latest, release
File[] files = Objects.requireNonNull(dir.getParent().toFile()
.listFiles(File::isDirectory));
File file = folderWithPredefinedName(files);
if (file != null) {
if (log.isDebugEnabled()) {
log.debug("Found folder with name corresponding to a latest version [" + file + "] ");
this.foundFile = file.toPath();
return FileVisitResult.TERMINATE;
}
}
return latestVersionFromFolders(dir, files);
} else {
this.foundFile = dir;
}
return FileVisitResult.TERMINATE;
}
return FileVisitResult.CONTINUE;
}
private FileVisitResult latestVersionFromFolders(Path dir, File[] files) {
List<DefaultArtifactVersionWrapper> versions = pickLatestVersion(files);
if (versions.isEmpty()) {
if (log.isDebugEnabled()) {
log.debug("Not a single version matching semver for path [" + dir.toAbsolutePath().toString() + "] was found");
}
return FileVisitResult.CONTINUE;
}
// 2.0.0.RELEASE, 2.0.0.BUILD-SNAPSHOT
// 2.0.0.RELEASE
DefaultArtifactVersionWrapper latestFoundVersion = versions.get(versions.size() - 1);
latestFoundVersion = replaceWithSnapshotIfSameVersions(versions, latestFoundVersion);
this.foundFile = latestFoundVersion.file.toPath();
return FileVisitResult.TERMINATE;
}
private DefaultArtifactVersionWrapper replaceWithSnapshotIfSameVersions(List<DefaultArtifactVersionWrapper> versions, DefaultArtifactVersionWrapper latestFoundVersion) {
if (versions.size() > 1 && this.latestSnapshotVersion) {
// 2.0.0.BUILD-SNAPSHOT
DefaultArtifactVersionWrapper versionWrapper = versions.get(versions.size() - 2);
// 2.0.0 vs 2.0.0
boolean sameVersionsWithoutClassifier = Objects.equals(withoutClassifier(versionWrapper), withoutClassifier(latestFoundVersion));
// replace the RELEASE one with SNAPSHOT
latestFoundVersion = sameVersionsWithoutClassifier && versionWrapper.isSnapshot() ? versionWrapper : latestFoundVersion;
}
return latestFoundVersion;
}
private String withoutClassifier(DefaultArtifactVersionWrapper versionWrapper) {
String version = versionWrapper.version.toString();
return version.substring(0, version.lastIndexOf("."));
}
private File folderWithPredefinedName(File[] files) {
if (this.latestSnapshotVersion) {
return Arrays.stream(files)
.filter(file -> LATEST.stream()
.anyMatch(s -> s.equals(file.getName().toLowerCase())))
.findFirst().orElse(null);
}
return Arrays.stream(files)
.filter(file -> RELEASE.equals(file.getName().toLowerCase()))
.findFirst().orElse(null);
}
private List<DefaultArtifactVersionWrapper> pickLatestVersion(File[] files) {
return Arrays.stream(files)
.map(DefaultArtifactVersionWrapper::new)
.filter(wrapper -> this.latestSnapshotVersion || wrapper
.isNotSnapshot())
.sorted()
.collect(Collectors.toList());
}
}
class DefaultArtifactVersionWrapper implements Comparable<DefaultArtifactVersionWrapper> {
private static final String SNAPSHOT_SUBSTRING = "snapshot";
final DefaultArtifactVersion version;
final File file;
DefaultArtifactVersionWrapper(File file) {
this.version = new DefaultArtifactVersion(file.getName());
this.file = file;
}
boolean isSnapshot() {
return this.version.toString().toLowerCase().contains(SNAPSHOT_SUBSTRING);
}
boolean isNotSnapshot() {
return !isSnapshot();
}
@Override
public int compareTo(DefaultArtifactVersionWrapper o) {
return this.version.compareTo(o.version);
}
}

View File

@@ -102,24 +102,131 @@ public class GitStubDownloaderTests {
}
@Test
public void should_fail_to_fetch_stubs_when_latest_version_was_specified()
public void should_pick_latest_build_snapshot_stubs_when_latest_version_set()
throws URISyntaxException {
StubDownloaderBuilder stubDownloaderBuilder = new ScmStubDownloaderBuilder();
StubDownloader stubDownloader = stubDownloaderBuilder
.build(new StubRunnerOptionsBuilder()
.withStubsMode(StubRunnerProperties.StubsMode.REMOTE)
.withStubRepositoryRoot("git://"
+ file("/git_samples/contract-git").getAbsolutePath())
+ file("/git_samples/contract-git/").getAbsolutePath() + "/")
.withProperties(props()).build());
try {
stubDownloader.downloadAndUnpackStubJar(
new StubConfiguration("foo.bar:bazService:+"));
}
catch (IllegalStateException e) {
then(e).hasMessageContaining(
"Concrete version wasn't passed for [foo.bar:bazService:+:stubs]");
}
Map.Entry<StubConfiguration, File> entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:+"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "1.0.0.BUILD-SNAPSHOT");
entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:latest"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "1.0.0.BUILD-SNAPSHOT");
entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:LATEST"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "1.0.0.BUILD-SNAPSHOT");
}
@Test
public void should_pick_latest_release_stubs_when_release_version_set()
throws URISyntaxException {
StubDownloaderBuilder stubDownloaderBuilder = new ScmStubDownloaderBuilder();
StubDownloader stubDownloader = stubDownloaderBuilder
.build(new StubRunnerOptionsBuilder()
.withStubsMode(StubRunnerProperties.StubsMode.REMOTE)
.withStubRepositoryRoot("git://"
+ file("/git_samples/contract-git/").getAbsolutePath() + "/")
.withProperties(props()).build());
Map.Entry<StubConfiguration, File> entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:release"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "1.0.0.RELEASE");
entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:RELEASE"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "1.0.0.RELEASE");
}
@Test
public void should_pick_latest_build_snapshot_stubs_when_latest_version_set_and_latest_folder_exists()
throws URISyntaxException {
StubDownloaderBuilder stubDownloaderBuilder = new ScmStubDownloaderBuilder();
StubDownloader stubDownloader = stubDownloaderBuilder
.build(new StubRunnerOptionsBuilder()
.withStubsMode(StubRunnerProperties.StubsMode.REMOTE)
.withStubRepositoryRoot("git://"
+ file("/git_samples/contract-predefined-names-git/").getAbsolutePath() + "/")
.withProperties(props()).build());
Map.Entry<StubConfiguration, File> entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:+"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "latest");
entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:latest"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "latest");
entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:LATEST"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "latest");
}
@Test
public void should_pick_release_folder_when_release_version_set()
throws URISyntaxException {
StubDownloaderBuilder stubDownloaderBuilder = new ScmStubDownloaderBuilder();
StubDownloader stubDownloader = stubDownloaderBuilder
.build(new StubRunnerOptionsBuilder()
.withStubsMode(StubRunnerProperties.StubsMode.REMOTE)
.withStubRepositoryRoot("git://"
+ file("/git_samples/contract-predefined-names-git/").getAbsolutePath() + "/")
.withProperties(props()).build());
Map.Entry<StubConfiguration, File> entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:release"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "release");
entry = stubDownloader
.downloadAndUnpackStubJar(
new StubConfiguration("com.example:beer-api-producer-external:RELEASE"));
then(entry).isNotNull();
then(entry.getValue().getAbsolutePath()).contains("com.example" + File.separator
+ "beer-api-producer-external" + File.separator + "release");
}
@Test
@@ -130,7 +237,8 @@ public class GitStubDownloaderTests {
.build(new StubRunnerOptionsBuilder()
.withStubsMode(StubRunnerProperties.StubsMode.REMOTE)
.withStubRepositoryRoot("git://"
+ file("/git_samples/contract-git").getAbsolutePath())
+ file("/git_samples/contract-git").getAbsolutePath()
+ "/")
.withProperties(props()).build());
try {

View File

@@ -25,6 +25,7 @@ class TestUtils {
public static void prepareLocalRepo() throws IOException {
prepareLocalRepo("target/test-classes/git_samples/", "contract-git");
prepareLocalRepo("target/test-classes/git_samples/", "contract-predefined-names-git");
}
private static void prepareLocalRepo(String buildDir, String repoPath)

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -5,9 +5,6 @@
logallrefupdates = true
ignorecase = true
precomposeunicode = true
[remote "origin"]
url = git@github.com:marcingrzejszczak/contract-git.git
fetch = +refs/heads/*:refs/remotes/origin/*
[branch "master"]
remote = origin
merge = refs/heads/master

View File

@@ -1 +1,2 @@
0000000000000000000000000000000000000000 0b36113e5fa9713025d50f046e8fd209fc8d9597 Marcin Grzejszczak <mgrzejszczak@pivotal.io> 1522062299 +0200 clone: from git@github.com:marcingrzejszczak/contract-git.git
0b36113e5fa9713025d50f046e8fd209fc8d9597 3bd42890d5105a30abd82d0205b63cbf20a59e83 Marcin Grzejszczak <mgrzejszczak@pivotal.io> 1547107982 +0100 commit: Added more versions

View File

@@ -1 +1,2 @@
0000000000000000000000000000000000000000 0b36113e5fa9713025d50f046e8fd209fc8d9597 Marcin Grzejszczak <mgrzejszczak@pivotal.io> 1522062299 +0200 clone: from git@github.com:marcingrzejszczak/contract-git.git
0b36113e5fa9713025d50f046e8fd209fc8d9597 3bd42890d5105a30abd82d0205b63cbf20a59e83 Marcin Grzejszczak <mgrzejszczak@pivotal.io> 1547107982 +0100 commit: Added more versions

View File

@@ -0,0 +1 @@
x<01><>=N1@aj<61>b<EFBFBD>Hh<48><68><EFBFBD>"D**1<><31>`<60>]G^<5E>bO<62><4F>&<07><><CDA7><EFBFBD><EFBFBD> <09><><EFBFBD>9D<39>lk6<6B>tNNLu"Es<45><73>-<2D>!<21><>N&DϬn<d<><64>g㉌<67><E3898C>)<29>A<EFBFBD><41>Ê<EFBFBD>K<EFBFBD>Ec<45>9<EFBFBD><39>RP<52>;<3B><><EFBFBD>O<1E><><EFBFBD>1v<31><76><EFBFBD><EFBFBD><EFBFBD><05><>׳<EFBFBD>o<EFBFBD><6F>'__[r6<10>5<1C>U~<7E>N<EFBFBD><4E><EFBFBD>N<EFBFBD>H<EFBFBD><48><0F><><EFBFBD><EFBFBD><EFBFBD>uS<53>S<>

View File

@@ -1 +1 @@
0b36113e5fa9713025d50f046e8fd209fc8d9597
3bd42890d5105a30abd82d0205b63cbf20a59e83

View File

@@ -0,0 +1,202 @@
Apache License
Version 2.0, January 2004
http://www.apache.org/licenses/
TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
1. Definitions.
"License" shall mean the terms and conditions for use, reproduction,
and distribution as defined by Sections 1 through 9 of this document.
"Licensor" shall mean the copyright owner or entity authorized by
the copyright owner that is granting the License.
"Legal Entity" shall mean the union of the acting entity and all
other entities that control, are controlled by, or are under common
control with that entity. For the purposes of this definition,
"control" means (i) the power, direct or indirect, to cause the
direction or management of such entity, whether by contract or
otherwise, or (ii) ownership of fifty percent (50%) or more of the
outstanding shares, or (iii) beneficial ownership of such entity.
"You" (or "Your") shall mean an individual or Legal Entity
exercising permissions granted by this License.
"Source" form shall mean the preferred form for making modifications,
including but not limited to software source code, documentation
source, and configuration files.
"Object" form shall mean any form resulting from mechanical
transformation or translation of a Source form, including but
not limited to compiled object code, generated documentation,
and conversions to other media types.
"Work" shall mean the work of authorship, whether in Source or
Object form, made available under the License, as indicated by a
copyright notice that is included in or attached to the work
(an example is provided in the Appendix below).
"Derivative Works" shall mean any work, whether in Source or Object
form, that is based on (or derived from) the Work and for which the
editorial revisions, annotations, elaborations, or other modifications
represent, as a whole, an original work of authorship. For the purposes
of this License, Derivative Works shall not include works that remain
separable from, or merely link (or bind by name) to the interfaces of,
the Work and Derivative Works thereof.
"Contribution" shall mean any work of authorship, including
the original version of the Work and any modifications or additions
to that Work or Derivative Works thereof, that is intentionally
submitted to Licensor for inclusion in the Work by the copyright owner
or by an individual or Legal Entity authorized to submit on behalf of
the copyright owner. For the purposes of this definition, "submitted"
means any form of electronic, verbal, or written communication sent
to the Licensor or its representatives, including but not limited to
communication on electronic mailing lists, source code control systems,
and issue tracking systems that are managed by, or on behalf of, the
Licensor for the purpose of discussing and improving the Work, but
excluding communication that is conspicuously marked or otherwise
designated in writing by the copyright owner as "Not a Contribution."
"Contributor" shall mean Licensor and any individual or Legal Entity
on behalf of whom a Contribution has been received by Licensor and
subsequently incorporated within the Work.
2. Grant of Copyright License. Subject to the terms and conditions of
this License, each Contributor hereby grants to You a perpetual,
worldwide, non-exclusive, no-charge, royalty-free, irrevocable
copyright license to reproduce, prepare Derivative Works of,
publicly display, publicly perform, sublicense, and distribute the
Work and such Derivative Works in Source or Object form.
3. Grant of Patent License. Subject to the terms and conditions of
this License, each Contributor hereby grants to You a perpetual,
worldwide, non-exclusive, no-charge, royalty-free, irrevocable
(except as stated in this section) patent license to make, have made,
use, offer to sell, sell, import, and otherwise transfer the Work,
where such license applies only to those patent claims licensable
by such Contributor that are necessarily infringed by their
Contribution(s) alone or by combination of their Contribution(s)
with the Work to which such Contribution(s) was submitted. If You
institute patent litigation against any entity (including a
cross-claim or counterclaim in a lawsuit) alleging that the Work
or a Contribution incorporated within the Work constitutes direct
or contributory patent infringement, then any patent licenses
granted to You under this License for that Work shall terminate
as of the date such litigation is filed.
4. Redistribution. You may reproduce and distribute copies of the
Work or Derivative Works thereof in any medium, with or without
modifications, and in Source or Object form, provided that You
meet the following conditions:
(a) You must give any other recipients of the Work or
Derivative Works a copy of this License; and
(b) You must cause any modified files to carry prominent notices
stating that You changed the files; and
(c) You must retain, in the Source form of any Derivative Works
that You distribute, all copyright, patent, trademark, and
attribution notices from the Source form of the Work,
excluding those notices that do not pertain to any part of
the Derivative Works; and
(d) If the Work includes a "NOTICE" text file as part of its
distribution, then any Derivative Works that You distribute must
include a readable copy of the attribution notices contained
within such NOTICE file, excluding those notices that do not
pertain to any part of the Derivative Works, in at least one
of the following places: within a NOTICE text file distributed
as part of the Derivative Works; within the Source form or
documentation, if provided along with the Derivative Works; or,
within a display generated by the Derivative Works, if and
wherever such third-party notices normally appear. The contents
of the NOTICE file are for informational purposes only and
do not modify the License. You may add Your own attribution
notices within Derivative Works that You distribute, alongside
or as an addendum to the NOTICE text from the Work, provided
that such additional attribution notices cannot be construed
as modifying the License.
You may add Your own copyright statement to Your modifications and
may provide additional or different license terms and conditions
for use, reproduction, or distribution of Your modifications, or
for any such Derivative Works as a whole, provided Your use,
reproduction, and distribution of the Work otherwise complies with
the conditions stated in this License.
5. Submission of Contributions. Unless You explicitly state otherwise,
any Contribution intentionally submitted for inclusion in the Work
by You to the Licensor shall be under the terms and conditions of
this License, without any additional terms or conditions.
Notwithstanding the above, nothing herein shall supersede or modify
the terms of any separate license agreement you may have executed
with Licensor regarding such Contributions.
6. Trademarks. This License does not grant permission to use the trade
names, trademarks, service marks, or product names of the Licensor,
except as required for reasonable and customary use in describing the
origin of the Work and reproducing the content of the NOTICE file.
7. Disclaimer of Warranty. Unless required by applicable law or
agreed to in writing, Licensor provides the Work (and each
Contributor provides its Contributions) on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
implied, including, without limitation, any warranties or conditions
of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
PARTICULAR PURPOSE. You are solely responsible for determining the
appropriateness of using or redistributing the Work and assume any
risks associated with Your exercise of permissions under this License.
8. Limitation of Liability. In no event and under no legal theory,
whether in tort (including negligence), contract, or otherwise,
unless required by applicable law (such as deliberate and grossly
negligent acts) or agreed to in writing, shall any Contributor be
liable to You for damages, including any direct, indirect, special,
incidental, or consequential damages of any character arising as a
result of this License or out of the use or inability to use the
Work (including but not limited to damages for loss of goodwill,
work stoppage, computer failure or malfunction, or any and all
other commercial damages or losses), even if such Contributor
has been advised of the possibility of such damages.
9. Accepting Warranty or Additional Liability. While redistributing
the Work or Derivative Works thereof, You may choose to offer,
and charge a fee for, acceptance of support, warranty, indemnity,
or other liability obligations and/or rights consistent with this
License. However, in accepting such obligations, You may act only
on Your own behalf and on Your sole responsibility, not on behalf
of any other Contributor, and only if You agree to indemnify,
defend, and hold each Contributor harmless for any liability
incurred by, or claims asserted against, such Contributor by reason
of your accepting any such warranty or additional liability.
END OF TERMS AND CONDITIONS
APPENDIX: How to apply the Apache License to your work.
To apply the Apache License to your work, attach the following
boilerplate notice, with the fields enclosed by brackets "[]"
replaced with your own identifying information. (Don't include
the brackets!) The text should be enclosed in the appropriate
comment syntax for the file format. We also recommend that a
file or class name and description of purpose be included on the
same "printed page" as the copyright notice for easier
identification within third-party archives.
Copyright [yyyy] [name of copyright owner]
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a positive verification message when person is eligible to get the beer
```
given:
client is old enough
when:
he applies for a beer
then:
we'll send a message with a positive verification
```
""")
// Label by means of which the output message can be triggered
label 'accepted_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsOldEnough()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: true
])
}
}

View File

@@ -0,0 +1,33 @@
package contracts.beer.messaging
org.springframework.cloud.contract.spec.Contract.make {
description("""
Sends a negative verification message when person is not eligible to get the beer
```
given:
client is too young
when:
he applies for a beer
then:
we'll send a message with a negative verification
```
""")
// Label by means of which the output message can be triggered
label 'rejected_verification'
// input to the contract
input {
// the contract will be triggered by a method
triggeredBy('clientIsTooYoung()')
}
// output message of the contract
outputMessage {
// destination to which the output message will be sent
sentTo 'verifications'
// the body of the output message
body([
eligible: false
])
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a successful scenario of getting a beer
given:
client is old enough
when:
he applies for a beer
then:
we'll grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[2-9][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,37 @@
package contracts.beer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
description("""
Represents a unsuccessful scenario of getting a beer
given:
client is not old enough
when:
he applies for a beer
then:
we'll NOT grant him the beer
""")
method 'POST'
url '/check'
body(
age: value(consumer(regex('[0-1][0-9]')))
)
headers {
header 'Content-Type', 'application/json'
}
}
response {
status 200
body( """
{
"status": "NOT_OK"
}
""")
headers {
header(
'Content-Type', value(consumer('application/json'),producer(regex('application/json.*')))
)
}
}
}

View File

@@ -0,0 +1,24 @@
{
"id" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[2-9][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "e5413ef6-0f3e-4b81-9e78-7a90b53c6ed1"
}

View File

@@ -0,0 +1,24 @@
{
"id" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08",
"request" : {
"url" : "/check",
"method" : "POST",
"headers" : {
"Content-Type" : {
"equalTo" : "application/json"
}
},
"bodyPatterns" : [ {
"matchesJsonPath" : "$[?(@.['age'] =~ /[0-1][0-9]/)]"
} ]
},
"response" : {
"status" : 200,
"body" : "{\"status\":\"NOT_OK\"}",
"headers" : {
"Content-Type" : "application/json"
},
"transformers" : [ "response-template" ]
},
"uuid" : "b54426aa-b2ef-4b12-adc9-a05fcf6a4e08"
}

View File

@@ -0,0 +1,11 @@
package contracts.foo.bar.bazService.bazConsumer.rest
org.springframework.cloud.contract.spec.Contract.make {
request {
method 'GET'
url '/hello'
}
response {
status 200
}
}

View File

@@ -0,0 +1,12 @@
{
"id" : "f4080f7d-4cb2-4301-81d6-492570316aae",
"request" : {
"url" : "/hello",
"method" : "GET"
},
"response" : {
"status" : 200,
"transformers" : [ "response-template" ]
},
"uuid" : "f4080f7d-4cb2-4301-81d6-492570316aae"
}

View File

@@ -0,0 +1,70 @@
= Common contracts repo
This repo contains all contracts for apps in the system.
== As a consumer
You are working offline in order to play around with the API of the producer.
What you need to do is to have the producer's stubs installed locally. To do that
you have to (from the root of the repo)
[source,bash]
----
cd src/main/resources/contracts/com/example/beer-api-producer-external/1.0.0
mvn clean install -DskipTests
----
Then if you do `ls ./target` you'll see `beer-api-producer-external-0.0.1-SNAPSHOT-stubs.jar`. This jar will
contain the stubs generated from your contracts. That way you
can reference the `com.example:server:+:stubs` dependency in your consumer tests.
TIP: Don't mind that there's a version mismatch in the stubs and the folder structure.
The version number is there in the folder name for tests related to dealing with
non-Java friendly naming of packages.
== As a producer
Assuming that the consumers have filed a PR with the proposed contract the producers
can work offline to generate tests and stubs. To work offline, as a producer you just have
to go to the root folder of the contracts and:
[source,bash]
----
./mvnw clean install -DskipTests
----
Then if you do `ls ./target` you'll see `contracts-0.0.1-SNAPSHOT.jar`. This file contains
all DSL contracts, for all applications.
Now the producer can include the `contracts-0.0.1-SNAPSHOT.jar` from your local maven repository.
You can achieve that by setting the proper flag in plugin properties.
Example for Maven
[source,xml]
----
<plugin>
<groupId>org.springframework.cloud</groupId>
<artifactId>spring-cloud-contract-maven-plugin</artifactId>
<configuration>
<!-- url not required for working locally -->
<contractsWorkOffline>true<contractsWorkOffline>
<contractDependency>
<groupId>com.example</groupId>
<artifactId>beer-contracts</artifactId>
</contractDependency>
</configuration>
</plugin>
----
and for Gradle:
[source,groovy]
----
contracts {
contractsWorkOffline = true
contractDependency {
stringNotation = "com.example:beer-contracts"
}
}
----

View File

@@ -0,0 +1,10 @@
[core]
repositoryformatversion = 0
filemode = true
bare = false
logallrefupdates = true
ignorecase = true
precomposeunicode = true
[branch "master"]
remote = origin
merge = refs/heads/master

View File

@@ -0,0 +1 @@
Unnamed repository; edit this file 'description' to name the repository.

View File

@@ -0,0 +1,15 @@
#!/bin/sh
#
# An example hook script to check the commit log message taken by
# applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit. The hook is
# allowed to edit the commit message file.
#
# To enable this hook, rename this file to "applypatch-msg".
. git-sh-setup
commitmsg="$(git rev-parse --git-path hooks/commit-msg)"
test -x "$commitmsg" && exec "$commitmsg" ${1+"$@"}
:

View File

@@ -0,0 +1,24 @@
#!/bin/sh
#
# An example hook script to check the commit log message.
# Called by "git commit" with one argument, the name of the file
# that has the commit message. The hook should exit with non-zero
# status after issuing an appropriate message if it wants to stop the
# commit. The hook is allowed to edit the commit message file.
#
# To enable this hook, rename this file to "commit-msg".
# Uncomment the below to add a Signed-off-by line to the message.
# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
# hook is more suited to it.
#
# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
# This example catches duplicate Signed-off-by lines.
test "" = "$(grep '^Signed-off-by: ' "$1" |
sort | uniq -c | sed -e '/^[ ]*1[ ]/d')" || {
echo >&2 Duplicate Signed-off-by lines.
exit 1
}

View File

@@ -0,0 +1,8 @@
#!/bin/sh
#
# An example hook script to prepare a packed repository for use over
# dumb transports.
#
# To enable this hook, rename this file to "post-update".
exec git update-server-info

View File

@@ -0,0 +1,14 @@
#!/bin/sh
#
# An example hook script to verify what is about to be committed
# by applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-applypatch".
. git-sh-setup
precommit="$(git rev-parse --git-path hooks/pre-commit)"
test -x "$precommit" && exec "$precommit" ${1+"$@"}
:

View File

@@ -0,0 +1,49 @@
#!/bin/sh
#
# An example hook script to verify what is about to be committed.
# Called by "git commit" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message if
# it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-commit".
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)
# Redirect output to stderr.
exec 1>&2
# Cross platform projects tend to avoid non-ASCII filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
# Note that the use of brackets around a tr range is ok here, (it's
# even required, for portability to Solaris 10's /usr/bin/tr), since
# the square bracket bytes happen to fall in the designated range.
test $(git diff --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then
cat <<\EOF
Error: Attempt to add a non-ASCII file name.
This can cause problems if you want to work with people on other platforms.
To be portable it is advisable to rename the file.
If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
exit 1
fi
# If there are whitespace errors, print the offending file names and fail.
exec git diff-index --check --cached $against --

View File

@@ -0,0 +1,53 @@
#!/bin/sh
# An example hook script to verify what is about to be pushed. Called by "git
# push" after it has checked the remote status, but before anything has been
# pushed. If this script exits with a non-zero status nothing will be pushed.
#
# This hook is called with the following parameters:
#
# $1 -- Name of the remote to which the push is being done
# $2 -- URL to which the push is being done
#
# If pushing without using a named remote those arguments will be equal.
#
# Information about the commits which are being pushed is supplied as lines to
# the standard input in the form:
#
# <local ref> <local sha1> <remote ref> <remote sha1>
#
# This sample shows how to prevent push of commits where the log message starts
# with "WIP" (work in progress).
remote="$1"
url="$2"
z40=0000000000000000000000000000000000000000
while read local_ref local_sha remote_ref remote_sha
do
if [ "$local_sha" = $z40 ]
then
# Handle delete
:
else
if [ "$remote_sha" = $z40 ]
then
# New branch, examine all commits
range="$local_sha"
else
# Update to existing branch, examine new commits
range="$remote_sha..$local_sha"
fi
# Check for WIP commit
commit=`git rev-list -n 1 --grep '^WIP' "$range"`
if [ -n "$commit" ]
then
echo >&2 "Found WIP commit in $local_ref, not pushing"
exit 1
fi
fi
done
exit 0

View File

@@ -0,0 +1,169 @@
#!/bin/sh
#
# Copyright (c) 2006, 2008 Junio C Hamano
#
# The "pre-rebase" hook is run just before "git rebase" starts doing
# its job, and can prevent the command from running by exiting with
# non-zero status.
#
# The hook is called with the following parameters:
#
# $1 -- the upstream the series was forked from.
# $2 -- the branch being rebased (or empty when rebasing the current branch).
#
# This sample shows how to prevent topic branches that are already
# merged to 'next' branch from getting rebased, because allowing it
# would result in rebasing already published history.
publish=next
basebranch="$1"
if test "$#" = 2
then
topic="refs/heads/$2"
else
topic=`git symbolic-ref HEAD` ||
exit 0 ;# we do not interrupt rebasing detached HEAD
fi
case "$topic" in
refs/heads/??/*)
;;
*)
exit 0 ;# we do not interrupt others.
;;
esac
# Now we are dealing with a topic branch being rebased
# on top of master. Is it OK to rebase it?
# Does the topic really exist?
git show-ref -q "$topic" || {
echo >&2 "No such branch $topic"
exit 1
}
# Is topic fully merged to master?
not_in_master=`git rev-list --pretty=oneline ^master "$topic"`
if test -z "$not_in_master"
then
echo >&2 "$topic is fully merged to master; better remove it."
exit 1 ;# we could allow it, but there is no point.
fi
# Is topic ever merged to next? If so you should not be rebasing it.
only_next_1=`git rev-list ^master "^$topic" ${publish} | sort`
only_next_2=`git rev-list ^master ${publish} | sort`
if test "$only_next_1" = "$only_next_2"
then
not_in_topic=`git rev-list "^$topic" master`
if test -z "$not_in_topic"
then
echo >&2 "$topic is already up-to-date with master"
exit 1 ;# we could allow it, but there is no point.
else
exit 0
fi
else
not_in_next=`git rev-list --pretty=oneline ^${publish} "$topic"`
/usr/bin/perl -e '
my $topic = $ARGV[0];
my $msg = "* $topic has commits already merged to public branch:\n";
my (%not_in_next) = map {
/^([0-9a-f]+) /;
($1 => 1);
} split(/\n/, $ARGV[1]);
for my $elem (map {
/^([0-9a-f]+) (.*)$/;
[$1 => $2];
} split(/\n/, $ARGV[2])) {
if (!exists $not_in_next{$elem->[0]}) {
if ($msg) {
print STDERR $msg;
undef $msg;
}
print STDERR " $elem->[1]\n";
}
}
' "$topic" "$not_in_next" "$not_in_master"
exit 1
fi
<<\DOC_END
This sample hook safeguards topic branches that have been
published from being rewound.
The workflow assumed here is:
* Once a topic branch forks from "master", "master" is never
merged into it again (either directly or indirectly).
* Once a topic branch is fully cooked and merged into "master",
it is deleted. If you need to build on top of it to correct
earlier mistakes, a new topic branch is created by forking at
the tip of the "master". This is not strictly necessary, but
it makes it easier to keep your history simple.
* Whenever you need to test or publish your changes to topic
branches, merge them into "next" branch.
The script, being an example, hardcodes the publish branch name
to be "next", but it is trivial to make it configurable via
$GIT_DIR/config mechanism.
With this workflow, you would want to know:
(1) ... if a topic branch has ever been merged to "next". Young
topic branches can have stupid mistakes you would rather
clean up before publishing, and things that have not been
merged into other branches can be easily rebased without
affecting other people. But once it is published, you would
not want to rewind it.
(2) ... if a topic branch has been fully merged to "master".
Then you can delete it. More importantly, you should not
build on top of it -- other people may already want to
change things related to the topic as patches against your
"master", so if you need further changes, it is better to
fork the topic (perhaps with the same name) afresh from the
tip of "master".
Let's look at this example:
o---o---o---o---o---o---o---o---o---o "next"
/ / / /
/ a---a---b A / /
/ / / /
/ / c---c---c---c B /
/ / / \ /
/ / / b---b C \ /
/ / / / \ /
---o---o---o---o---o---o---o---o---o---o---o "master"
A, B and C are topic branches.
* A has one fix since it was merged up to "next".
* B has finished. It has been fully merged up to "master" and "next",
and is ready to be deleted.
* C has not merged to "next" at all.
We would want to allow C to be rebased, refuse A, and encourage
B to be deleted.
To compute (1):
git rev-list ^master ^topic next
git rev-list ^master next
if these match, topic has not merged in next at all.
To compute (2):
git rev-list master..topic
if this is empty, it is fully merged to "master".
DOC_END

View File

@@ -0,0 +1,24 @@
#!/bin/sh
#
# An example hook script to make use of push options.
# The example simply echoes all push options that start with 'echoback='
# and rejects all pushes when the "reject" push option is used.
#
# To enable this hook, rename this file to "pre-receive".
if test -n "$GIT_PUSH_OPTION_COUNT"
then
i=0
while test "$i" -lt "$GIT_PUSH_OPTION_COUNT"
do
eval "value=\$GIT_PUSH_OPTION_$i"
case "$value" in
echoback=*)
echo "echo from the pre-receive-hook: ${value#*=}" >&2
;;
reject)
exit 1
esac
i=$((i + 1))
done
fi

View File

@@ -0,0 +1,36 @@
#!/bin/sh
#
# An example hook script to prepare the commit log message.
# Called by "git commit" with the name of the file that has the
# commit message, followed by the description of the commit
# message's source. The hook's purpose is to edit the commit
# message file. If the hook fails with a non-zero status,
# the commit is aborted.
#
# To enable this hook, rename this file to "prepare-commit-msg".
# This hook includes three examples. The first comments out the
# "Conflicts:" part of a merge commit.
#
# The second includes the output of "git diff --name-status -r"
# into the message, just before the "git status" output. It is
# commented because it doesn't cope with --amend or with squashed
# commits.
#
# The third example adds a Signed-off-by line to the message, that can
# still be edited. This is rarely a good idea.
case "$2,$3" in
merge,)
/usr/bin/perl -i.bak -ne 's/^/# /, s/^# #/#/ if /^Conflicts/ .. /#/; print' "$1" ;;
# ,|template,)
# /usr/bin/perl -i.bak -pe '
# print "\n" . `git diff --cached --name-status -r`
# if /^#/ && $first++ == 0' "$1" ;;
*) ;;
esac
# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"

View File

@@ -0,0 +1,128 @@
#!/bin/sh
#
# An example hook script to block unannotated tags from entering.
# Called by "git receive-pack" with arguments: refname sha1-old sha1-new
#
# To enable this hook, rename this file to "update".
#
# Config
# ------
# hooks.allowunannotated
# This boolean sets whether unannotated tags will be allowed into the
# repository. By default they won't be.
# hooks.allowdeletetag
# This boolean sets whether deleting tags will be allowed in the
# repository. By default they won't be.
# hooks.allowmodifytag
# This boolean sets whether a tag may be modified after creation. By default
# it won't be.
# hooks.allowdeletebranch
# This boolean sets whether deleting branches will be allowed in the
# repository. By default they won't be.
# hooks.denycreatebranch
# This boolean sets whether remotely creating branches will be denied
# in the repository. By default this is allowed.
#
# --- Command line
refname="$1"
oldrev="$2"
newrev="$3"
# --- Safety check
if [ -z "$GIT_DIR" ]; then
echo "Don't run this script from the command line." >&2
echo " (if you want, you could supply GIT_DIR then run" >&2
echo " $0 <ref> <oldrev> <newrev>)" >&2
exit 1
fi
if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then
echo "usage: $0 <ref> <oldrev> <newrev>" >&2
exit 1
fi
# --- Config
allowunannotated=$(git config --bool hooks.allowunannotated)
allowdeletebranch=$(git config --bool hooks.allowdeletebranch)
denycreatebranch=$(git config --bool hooks.denycreatebranch)
allowdeletetag=$(git config --bool hooks.allowdeletetag)
allowmodifytag=$(git config --bool hooks.allowmodifytag)
# check for no description
projectdesc=$(sed -e '1q' "$GIT_DIR/description")
case "$projectdesc" in
"Unnamed repository"* | "")
echo "*** Project description file hasn't been set" >&2
exit 1
;;
esac
# --- Check types
# if $newrev is 0000...0000, it's a commit to delete a ref.
zero="0000000000000000000000000000000000000000"
if [ "$newrev" = "$zero" ]; then
newrev_type=delete
else
newrev_type=$(git cat-file -t $newrev)
fi
case "$refname","$newrev_type" in
refs/tags/*,commit)
# un-annotated tag
short_refname=${refname##refs/tags/}
if [ "$allowunannotated" != "true" ]; then
echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
exit 1
fi
;;
refs/tags/*,delete)
# delete tag
if [ "$allowdeletetag" != "true" ]; then
echo "*** Deleting a tag is not allowed in this repository" >&2
exit 1
fi
;;
refs/tags/*,tag)
# annotated tag
if [ "$allowmodifytag" != "true" ] && git rev-parse $refname > /dev/null 2>&1
then
echo "*** Tag '$refname' already exists." >&2
echo "*** Modifying a tag is not allowed in this repository." >&2
exit 1
fi
;;
refs/heads/*,commit)
# branch
if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
echo "*** Creating a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/heads/*,delete)
# delete branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/remotes/*,commit)
# tracking branch
;;
refs/remotes/*,delete)
# delete tracking branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a tracking branch is not allowed in this repository" >&2
exit 1
fi
;;
*)
# Anything else (is there anything else?)
echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
exit 1
;;
esac
# --- Finished
exit 0

Some files were not shown because too many files have changed in this diff Show More